"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com

Visuse is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""
"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com

Visuse is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""
# -*- coding: utf-8 -*-
#!/usr/bin/python

import gdata.youtube
import gdata.youtube.service
import json
from classes import Resultado, ImageLink



class Youtube(Resultado):
    def __init__(self, name, url, summary, tags, view_count, rating, thumbnails, player_url):
        Resultado.__init__(self, name, url)
        self.summary = summary
        self.tags = tags
        self.view_count = view_count
        self.rating = rating
        self.thumbnails = thumbnails
        self.player_url = player_url
		
		
def AddResult(resultList, entry):
	thumbnailList = []
	
	for thumb in entry.media.thumbnail:
		thumbnail = ImageLink(thumb.url, thumb.width, thumb.height)
		thumbnailList.append(thumbnail)
		#~ thumbnailList.append(thumb.url);
	
	resultList.append(Youtube( \
		entry.media.title.text, \
		entry.media.player.url, \
		entry.media.description.text, \
		entry.media.keywords.text, \
		entry.statistics.view_count, \
		entry.rating.average, \
		thumbnailList, \
		entry.GetSwfUrl() \
	))


def PrintYoutube(resultList):
	for n in range(0, len(resultList)):
		print '=====', n, '====='
		print resultList[n].name
		print resultList[n].url
		print resultList[n].summary
		print resultList[n].thumbnails[3]
		print '\n'


def SearchYoutube(search_terms):
	
	yt_service = gdata.youtube.service.YouTubeService()
	yt_service.developer_key = 'AI39si7_wU7vWxD_tYzS6oREhUqlw7rUzIgwW65XdlVk5nDnaLgxXhol8g-SwFLtWCJhDG4p_q5ilBT3FgODvr4B3Knyq7wtWg'

	resultList = []
	
	query = gdata.youtube.service.YouTubeVideoQuery()
	query.vq = search_terms
	query.orderby = 'relevance'
	query.racy = 'include'
	feed = yt_service.YouTubeQuery(query)
	
	for entry in feed.entry:
			AddResult(resultList, entry)

	#~ PrintYoutube(resultList)
	
	return resultList


#~ resultList = SearchYoutube('big bang theory')



